/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mapping;

import collection.c;
import java.util.List;

/**
 * Mapping Operation : Stands for operation between two mapping result to one value,
 * This is very convenient to use on a Context.
 * @author mtomono
 */
public class MOp<T> implements Mapping<T, Number> {
    Mapping<List<Number>, Number> body;
    Mapping<? super T, ? extends Number> mapping1;
    Mapping<? super T, ? extends Number> mapping2;
    
    public MOp(Mapping<List<Number>, Number> body, Mapping<? super T, ? extends Number> mapping1, Mapping<? super T, ? extends Number> mapping2) {
        this.body = body;
        this.mapping1 = mapping1;
        this.mapping2 = mapping2;
    }
    
    @Override
    public Number of(T target) {
        return body.of(c.<Number>a2l(mapping1.of(target), mapping2.of(target)));
    }

    @Override
    public boolean isReady(T target) {
        return mapping1.isReady(target) && mapping2.isReady(target);
    }
}
