/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mapping.reflection;

import collection.c;
import collection.m;
import iterator.driver.ForAll;
import iterator.mapping.Collect;
import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import mapping.Id;
import mapping.IsReady;
import mapping.Mapping;
import mapping.Of;
import mapping.ToConst;
import mapping.o;

/**
 *
 * @author mtomono
 */
public class Call<IN, OUT> extends Reflection<IN, OUT> {
    Mapping<? super IN, ?> called;
    List<Mapping<? super IN, ?>> args;
    public static <IN, OUT> Call<IN, OUT> c(String name, Object... args) {
        Mapping<Object[], Iterator<Mapping<Object, Object>>> toConst = new o<>(new Collect<Object, Mapping<Object, Object>>(new ToConst<>()), m.<Object>a2i());
        Mapping[] margs = new Mapping[args.length];
        int i = 0;
        Iterator<Mapping<Object, Object>> iter = toConst.of(args);
        while (iter.hasNext()) {
            margs[i++] = iter.next();
        }
        return new Call<>(name, new Id<>(), margs);
    }
    
    public Call(String name, Mapping<? super IN, ?> called, Mapping<? super IN, ?>... args) {
        super(name);
        this.called = called;
        this.args = c.a2l(args);
    }

    @Override
    public OUT value(IN target) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException, NoSuchMethodException, InvocationTargetException {
        Mapping<List<Mapping<? super IN, ? extends Object>>, Iterator<Object>> toObjects = new o<>(new Collect<Mapping<? super IN, ? extends Object>, Object>(new Of<>(target)), m.<Mapping<? super IN, ? extends Object>>l2i());
        Mapping<List<Mapping<? super IN, ? extends Object>>, Iterator<Class>> toClasses = new o<>(new Collect<Object,Class>(new o(Core.class2primitive, new ToClass())), toObjects);
        Object x = called.of(target);
        Class<?>[] classes = new Class[args.size()];
        Iterator<Class> iter = toClasses.of(args);
        int i = 0;
        while (iter.hasNext()) {
            classes[i++] = (Class)iter.next();
        }
        return (OUT)x.getClass().getMethod(name, classes).invoke(x, new o<>(m.i2a, toObjects).of(args));
    }
    
    @Override
    public String toString() {
        return called.toString() + ".of(x)." + name + "("+ args.toString() + ")";
    }

    @Override
    public boolean isReady(IN target) {
        if (!called.isReady(target))
            return false;
        return new ForAll(new IsReady<>(new Of<>(target))).of(args.iterator());
    }
}
